<?php
/*                                                                                                                                                       
  mememe                                     ememem
    \ememememem                       ememememem/ 
     ememememememem               ememememememem  
      emememememememe           emememememememe   
         \memememememem       ememememememe/      
         emememememememe     emememememememe     
                 emememem   ememememe              
                     ememe ememe                   
                       emememe                     
                         eme
                          e      
							           
	^^ Title : SEO Tag( hreflang )							 
	^^ Create : 2017-01-13
	^^ Copyright : EAGLEMEDIA.de  
*/
	# Reports for either E_ERROR | E_WARNING | 
	# E_NOTICE | Any Error
	#
	#ini_set("display_startup_errors", 1);
	#ini_set("display_errors", 1);
	#error_reporting(E_ALL);

if (!defined('_CAN_LOAD_FILES_'))
	exit;

class HrefLang4Country extends Module
{
	
    public function __construct()
	{
		$this->name = 'hreflang4country';
        $this->tab = 'seo';
		$this->version = '1.5.2';
		$this->author = 'EAGLEMEDIA.de';
		$this->need_instance = 0;

		$this->bootstrap = true;
		parent::__construct();	
		
		$this->displayName = $this->l('Linktag( hreflang )');
		$this->description = $this->l('Adding link -tags with hreflang attributes in header of the page. For Multishop -versions');
		$this->ps_versions_compliancy = array('min' => '1.5.0.0', 'max' => '1.6.1.24');
		$this->confirmUninstall = $this->l('Are you sure you want to uninstall this module?');
	}
	
    public function install()
	{
		$this->_clearCache('hook/hreflang4country.tpl');
		if (!parent::install()		
	    OR  !$this->registerHook('header')
		OR  !$this->registerHook('backOfficeHeader')
		OR  !Configuration::updateValue('HREFLANG_MULTISHOP', 0)
		OR  !Configuration::updateValue('HREFLANG_LANG_ROOM', '')
		OR  !Configuration::updateValue('HREFLANG_URLS_LANG', '')
		OR  !Configuration::updateValue('HREFLANG_URLS_WWW', 0)
		OR  !Configuration::updateValue('HREFLANG_URLS', $this->domainsToString()) )
			return false;
		return true;
	}

    public function uninstall()	
	{	
		$this->_clearCache('hook/hreflang4country.tpl');	    
		if (!parent::uninstall()
		OR  !$this->unregisterHook('header')
		OR  !$this->unregisterHook('backOfficeHeader')
		OR  !Configuration::deleteByName('HREFLANG_MULTISHOP')
		OR  !Configuration::deleteByName('HREFLANG_LANG_ROOM')
		OR  !Configuration::deleteByName('HREFLANG_URLS_LANG')
		OR  !Configuration::deleteByName('HREFLANG_URLS_WWW')
		OR  !Configuration::deleteByName('HREFLANG_URLS'))
			return false;
		return true;
	}
	
    private function domainsToString()	
	{
		$shops = Shop::getContextListShopID();
		foreach ($shops as $shop)
			$shop_domains .= $this->getDomains( $shop ).', ';

		return $shop_domains;	
	}
	
	private function getDomains( $id_shop )
	{
	    $result = Db::getInstance()->executeS('
			SELECT *
			FROM '._DB_PREFIX_.'shop_url
			WHERE active = 1
				AND id_shop = '.(int)$id_shop 
		);				
		
  
		if( Tools::usingSecureMode() )
		{
			foreach( $result as $key => $value )			
				$domain = $value['domain_ssl'];
		}
		else
		{				
			foreach( $result as $key => $value )			
				$domain = $value['domain'];
		}
		
		$domain = (substr($domain, 0, 4) =='www.') ? substr($domain, 4) : $domain;
		
		return $domain;
	}

    private function langIdsToString()	
	{		
		$iso_codes = explode(',', Configuration::get('HREFLANG_URLS_LANG'));
		foreach ( $iso_codes as $iso_code )
			$ids_lang .= $this->getDomainsLangId( $iso_code ).',';
		
		return $ids_lang;
	}	
	
	private function getDomainsLangId( $iso_code )
	{
	    $result = Db::getInstance()->getRow('
			SELECT id_lang
			FROM '._DB_PREFIX_.'lang
			WHERE active = 1
				AND iso_code = \''.pSQL($iso_code).'\''
		);
			
		return $result['id_lang'];
	}

	private function postProcess()
	{		
		if( Tools::isSubmit('submitShopStatus') )
		{			
			if( Tools::getValue('HREFLANG_MULTISHOP') == 1 )
			{
			    Configuration::updateValue('HREFLANG_MULTISHOP', 1);				
				Configuration::updateValue('HREFLANG_LANG_ROOM', str_replace('
',',', Tools::getValue('HREFLANG_LANG_ROOM')));
				Configuration::updateValue('HREFLANG_URLS_LANG', str_replace('
',',', Tools::getValue('HREFLANG_URLS_LANG')));
// <<<<<<<<<<<<<<< flush left !
                
				if( Tools::getValue('HREFLANG_URLS_WWW') == 1 ) 
				    Configuration::updateValue('HREFLANG_URLS_WWW', 1);
				else
				    Configuration::updateValue('HREFLANG_URLS_WWW', 0);

			    $this->_clearCache('hook/hreflang4country.tpl');										    
				return $this->displayConfirmation($this->l('The settings for MultiShop have been updated.'));
			}
			elseif( Tools::getValue('HREFLANG_MULTISHOP') == 0 )
			{
			    Configuration::updateValue('HREFLANG_MULTISHOP', 0);
				
			    $this->_clearCache('hook/hreflang4country.tpl');				
				return $this->displayConfirmation($this->l('The settings for SingleShop have been updated.'));
			}
		}
		
		return '';	
	}
			
	public function getContent()
	{
		return $this->postProcess().$this->renderForm();
	}

    public function renderForm()
	{
		$fields_form = array(
			'form' => array(			    
				'legend' => array(
					'title' => $this->l('Settings'),
					'icon' => 'icon-cogs'
				),
				'input' => array(					
					array( 
						'type' => 'switch',
						'label' => $this->l('Multishop'),
						'name' => 'HREFLANG_MULTISHOP',												
						'values' => array(
							array(
								'id' => 'active_on',
								'value' => 1,
								'label' => $this->l('Yes')
							),
							array(
								'id' => 'active_off',
								'value' => 0,
								'label' => $this->l('No')
							)
						)
					),
					array(
						'type' => 'textarea',
						'label' => $this->l('Shop domains'),
						'name' => 'HREFLANG_URLS',
						'rows' => 15,
						'cols' => 60,
						'desc' => $this->l('This domains are from database and not overwritable .')					
					),
					array(
						'type' => 'textarea',						
						'name' => 'HREFLANG_LANG_ROOM',
						'rows' => 15,
						'cols' => 8,						
						'desc' => $this->l('Write language -room code \' vertical \' passed to country : \' de-ch \'')
					),
					array(
						'type' => 'textarea',						
						'name' => 'HREFLANG_URLS_LANG',
						'rows' => 15,
						'cols' => 8,						
						'desc' => $this->l('Write language code \' vertical \' passed to country : \' de \'')
					),
					array( 
						'type' => 'switch',
						'label' => $this->l('Your urls with \' www \' ?'),
						'name' => 'HREFLANG_URLS_WWW',												
						'values' => array(
							array(
								'id' => 'active_on',
								'value' => 1,
								'label' => $this->l('Yes')
							),
							array(
								'id' => 'active_off',
								'value' => 0,
								'label' => $this->l('No')
							)
						)
					)														
				),
				'submit' => array(
					'title' => $this->l('Save')
				)
			),
		);

		$helper = new HelperForm();
		$helper->show_toolbar = false;
		$helper->table =  $this->table;
		$lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
		$helper->default_form_language = $lang->id;
		$helper->module = $this;
		$helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;		
		$helper->identifier = $this->identifier;
		$helper->submit_action = 'submitShopStatus';
		$helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
		$helper->token = Tools::getAdminTokenLite('AdminModules');
		$helper->tpl_vars = array(
			'uri' => $this->getPathUri(),
			'fields_value' => $this->getConfigFieldsValues(),
			'languages' => $this->context->controller->getLanguages(),
			'id_language' => $this->context->language->id
		);

		return $helper->generateForm(array($fields_form));
	}
	
    public function getConfigFieldsValues()
    {
        return array(
            'HREFLANG_MULTISHOP' => Tools::getValue('HREFLANG_MULTISHOP', Configuration::get('HREFLANG_MULTISHOP')),
			'HREFLANG_URLS_WWW' => Tools::getValue('HREFLANG_URLS_WWW', Configuration::get('HREFLANG_URLS_WWW')),
			'HREFLANG_URLS' => str_replace(',','
', Configuration::get('HREFLANG_URLS')),
			'HREFLANG_LANG_ROOM' => Tools::getValue('HREFLANG_LANG_ROOM', str_replace(',','
', Configuration::get('HREFLANG_LANG_ROOM'))),
			'HREFLANG_URLS_LANG' => Tools::getValue('HREFLANG_URLS_LANG', str_replace(',','
', Configuration::get('HREFLANG_URLS_LANG')))
// <<<<<<<<<<<<<<< flush left !
        );
    }			

    #
	#
	#

	public function hookHeader($params)
	{
		#if( !$this->isCached('hook/hreflang4country.tpl', $this->getCacheId($column)) )
		#{
		    $lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));		    
			$s = Tools::usingSecureMode() ? 's' : '';
			$www = Configuration::get('HREFLANG_URLS_WWW') ? 'www.' : '';
			$ml = false;
			
			if( Language::isMultiLanguageActivated() )
				$ml = true;
			
			$array_urls = explode(',', str_replace(' ','', rtrim(Configuration::get('HREFLANG_URLS'), ', ')));
			$array_room = explode(',', Configuration::get('HREFLANG_LANG_ROOM'));
			$array_lang = explode(',', Configuration::get('HREFLANG_URLS_LANG'));
			$lang_ids = explode(',', rtrim($this->langIdsToString(), ', '));
            $array_urls_ = array();
            $i = 0;
			foreach( $array_urls as $url )
			{    
				$link = $this->context->link->getLanguageLink(($lang_ids[$i] ? $lang_ids[$i] : $lang->id));
				$linkSplits = explode('/', $link);
				
				$l = 0;
				$reqLink = '';
				foreach( $linkSplits as $linkSplit )
				{
					if ( $l > 2 )
						$reqLink .= '/'.$linkSplit;						
					$l++;
				}		
				
				$array_urls_[] = $url.$reqLink.','.$array_room[$i].','.$array_lang[$i];
				$i++;				
			}
			
			###########################
			#if( $_SERVER['REMOTE_ADDR'] =='2.247.248.27' 
			#  OR $_SERVER['HTTP_CLIENT_IP'] =='2.247.248.27' )				
			#	print_r($array_urls_);		
	        ###########################
			
            foreach( $array_urls_ as $url_ )
                $array_urls__[] = explode(',', $url_);
				
			###########################
			#if( $_SERVER['REMOTE_ADDR'] =='2.247.248.138' 
			#  OR $_SERVER['HTTP_CLIENT_IP'] =='2.247.248.138' )
			#	print_r($array_urls__);
	        ###########################

			$this->smarty->assign(
				array(
					'multishop' => Configuration::get('HREFLANG_MULTISHOP'),
					'multiarray' => $array_urls__,
					'ml' => $ml,
					's' => $s,
					'www' => $www					
				)
			);
		#}	
		return $this->display(__FILE__, 'hook/hreflang4country.tpl');
	}
	
	public function hookDisplayBackOfficeHeader()
	{			

		if ( ip2long(_PS_VERSION_) >= ip2long('1.4.0.0') 
		 AND ip2long(_PS_VERSION_)  < ip2long('1.7.0.0') )
		{
			$cssJS  = '
		<link type="text/css" rel="stylesheet" href="'.($this->_path.'css/admin/hreflang4country.css').'" />
		<script type="text/javascript" src="'.($this->_path.'js/admin/hreflang4country.js').'"></script>
			';
			
			return $cssJS;
		}
		
		if ( ip2long(_PS_VERSION_) >= ip2long('1.7.0.0') )
		{
	        $this->context->controller->addCSS($this->_path.'css/admin/hreflang4country.css', 'all');
			$this->context->controller->addJS($this->_path.'js/admin/hreflang4country.js', 'all');
		}
	}
	
}	
